import ujson
import uos


class FileQueue:
    def __init__(self):
        self.history_filename = '/usr/queue.txt'
        try:
            open(self.history_filename, 'r+')
        except Exception as ex:
            #if hasattr(ex, 'message'):
            #    print('fq1', ex.message)
            #else:
            #    print('fq1',ex)
            print('Creating default history file...')
            open(self.history_filename, "a").close()

    def add(self, item):
        with open(self.history_filename, 'a+') as file_pointer:
            if isinstance(item, dict):
                file_pointer.write(ujson.dumps(item) + '\n')
            else:
                file_pointer.write(ujson.dumps(item.__dict__) + '\n')

    def delete(self):
        with open(self.history_filename, 'r+') as file_pointer:
            try:
                lines = file_pointer.readlines()
                uos.remove(self.history_filename)

                with open(self.history_filename, 'a') as file_pointer2:
                    for i, line in enumerate(lines):
                        if i > 0:
                            file_pointer2.write(line)

                    file_pointer2.close()

                return True

            except Exception as ex:
                if hasattr(ex, 'message'):
                    print('fq2',ex.message)
                else:
                    print('fq2',ex)

                return False

    def pop(self):
        with open(self.history_filename, 'r+') as file_pointer:
            try:
                first_line = file_pointer.readline()
                return ujson.loads(first_line.strip('\n'))
            except Exception as ex:
                if hasattr(ex, 'message'):
                    print('fq3',ex.message)
                else:
                    print('fq3',ex)

                return None

    def count(self):
        return sum(1 for _ in open(self.history_filename))
